DatePalette
=============

**DatePalette** - фреймверк для создания вменяемых UI, работающих с датой, ака дата-пикеров.

![modal example](https://raw.github.com/Meettya/DatePalette/master/doc/modal_ru.png "modal example")

Disclaimer
-------

Проект находится в стадии активной разработки, многое может поменяться, на данный момент обратная совместимость для старых версий не гарантируется.

Да, на данный момент корректное отображение возможно только в IE8 и выше и во всех современных браузерах. В теории возможна доработка до поддержки IE7 (проблемы только в визуальном отображении, логика работает), но я этого делать не буду.

Summary
-------

Основная идея UI-фремверка - модульность, простота настройки, контроль для разработчика, удобство для конечного пользователя.

Кастомизация оформления - из коробки поддерживается jQuery темы, этого должно быть более чем достаточно.

Есть планы на развитие проекта, см. Roadmap

Usage
-------

Для начала следует разрешить все зависимости, например, как в тестовом примере, с помощью head.js.

Далее использовать DatePalette довольно просто, в самом базовом варианте (модальное окно ввода) нужно только указать цель, по клику на которую будет показан пикер и сообщить колбек, который должен быть выполнен при изменении даты.

```js
  DatePalette.init(target_id, cb);
```

Важно - колбек выполняется в контексте объекта, отображающего результат.

```js
  this.getResult()
```

Вернет нам то, что нужно - итоговое значение даты.

Позднее API будет описан подробнее.

Взято из тестового примера:

```js
  var DatePalette = require('datepalette');
  DatePalette.init("#date_palette_one", function() {
    $("#date_palette_one").val(this.getResult());
    return null;
  });
```

    <input id="date_palette_one" type="text" name="date_palette_one" readonly>


Более подробно смотрим public/index.html.

Dependencies
-------

Зависимостей много, мы стоим на плечах гигантов :)

+ jQuery
+ Underscore.js
+ Moment.js
+ Metamorph
+ jquery.foundation.reveal.js

Roadmap
-------

+ Дописывание view-модулей (отображение даты с днями недели и т.п.)
+ Переработка стилей и приведение их к БЭМ-нотации
+ Рефакторинг кода
+ Увеличение процента покрытия кода тестами
+ Пересмотр списка зависимостей на предмет их уменьшения или включения в сборку
+ Разработка cli-инструмента для сборки пикеров без лишних элементов
+ Разработка web-based системы сборки пикеров без лишних элементов, с помощником конфигурирования

Setup (for developer)
-------

1. Клонируем репозиторий
2. Устанавливаем модули `node install`

Теперь доступны следующие операции:

* `cake run_server` - запуск сервера разработчика с динамической сборкой
* `cake coffee` - запуск команды для компиляции статических .js и .min.js файлов
* `cake jade` - запуск команды для компиляции html (тестовой страницы) из jade


Qualität
-------

В данный момент на часть моделей, библиотек и помощников написаны тесты.

Запуск - `mocha` в корневой директории проекта.

Demo
-------

Демо страница online доступна здесь - http://jsfiddle.net/Meettya/aDAsa/embedded/result/